Skip to content
geeksforgeeks
  • Courses
    • DSA to Development
    • Get IBM Certification
    • Newly Launched!
      • Master Django Framework
      • Become AWS Certified
    • For Working Professionals
      • Interview 101: DSA & System Design
      • Data Science Training Program
      • JAVA Backend Development (Live)
      • DevOps Engineering (LIVE)
      • Data Structures & Algorithms in Python
    • For Students
      • Placement Preparation Course
      • Data Science (Live)
      • Data Structure & Algorithm-Self Paced (C++/JAVA)
      • Master Competitive Programming (Live)
      • Full Stack Development with React & Node JS (Live)
    • Full Stack Development
    • Data Science Program
    • All Courses
  • Tutorials
    • Data Structures & Algorithms
    • ML & Data Science
    • Interview Corner
    • Programming Languages
    • Web Development
    • CS Subjects
    • DevOps And Linux
    • School Learning
  • Practice
    • Build your AI Agent
    • GfG 160
    • Problem of the Day
    • Practice Coding Problems
    • GfG SDE Sheet
  • Contests
    • Accenture Hackathon (Ending Soon!)
    • GfG Weekly [Rated Contest]
    • Job-A-Thon Hiring Challenge
    • All Contests and Events
  • DSA
  • Interview Questions on Array
  • Practice Array
  • MCQs on Array
  • Tutorial on Array
  • Types of Arrays
  • Array Operations
  • Subarrays, Subsequences, Subsets
  • Reverse Array
  • Static Vs Arrays
  • Array Vs Linked List
  • Array | Range Queries
  • Advantages & Disadvantages
Open In App
Next Article:
C++ Program to Count pairs with given sum
Next article icon

C++ Program for Number of pairs with maximum sum

Last Updated : 13 Jan, 2022
Comments
Improve
Suggest changes
Like Article
Like
Report

Given an array arr[], count number of pairs arr[i], arr[j] such that arr[i] + arr[j] is maximum and i < j.

Example :  Input  : arr[] = {1, 1, 1, 2, 2, 2}  Output : 3  Explanation: The maximum possible pair   sum where i


Method 1 (Naive) 
Traverse a loop i from 0 to n, i.e length of the array and another loop j from i+1 to n to find all possible pairs with i C++

// CPP program to count pairs with maximum sum. #include <bits/stdc++.h> using namespace std;  // function to find the number of maximum pair sums int sum(int a[], int n) {     // traverse through all the pairs     int maxSum = INT_MIN;     for (int i = 0; i < n; i++)         for (int j = i + 1; j < n; j++)             maxSum = max(maxSum, a[i] + a[j]);      // traverse through all pairs and keep a count     // of the number of maximum pairs     int c = 0;     for (int i = 0; i < n; i++)         for (int j = i + 1; j < n; j++)             if (a[i] + a[j] == maxSum)                 c++;     return c; }  // driver program to test the above function int main() {     int array[] = { 1, 1, 1, 2, 2, 2 };     int n = sizeof(array) / sizeof(array[0]);     cout << sum(array, n);     return 0; } 

Output : 

3


Time complexity:O(n^2)

Method 2 (Efficient) 
If we take a closer look, we can notice following facts. 

  1. Maximum element is always part of solution
  2. If maximum element appears more than once, then result is maxCount * (maxCount - 1)/2. We basically need to choose 2 elements from maxCount (maxCountC2).
  3. If maximum element appears once, then result is equal to count of second maximum element. We can form a pair with every second max and max
C++
// CPP program to count pairs with maximum sum. #include <bits/stdc++.h> using namespace std;  // function to find the number of maximum pair sums int sum(int a[], int n) {     // Find maximum and second maximum elements.     // Also find their counts.     int maxVal = a[0], maxCount = 1;     int secondMax = INT_MIN, secondMaxCount;     for (int i = 1; i < n; i++) {         if (a[i] == maxVal)             maxCount++;         else if (a[i] > maxVal) {             secondMax = maxVal;             secondMaxCount = maxCount;             maxVal = a[i];             maxCount = 1;         }         else if (a[i] == secondMax) {             secondMax = a[i];             secondMaxCount++;         }         else if (a[i] > secondMax) {             secondMax = a[i];             secondMaxCount = 1;         }     }      // If maximum element appears more than once.     if (maxCount > 1)         return maxCount * (maxCount - 1) / 2;      // If maximum element appears only once.     return secondMaxCount; }  // driver program to test the above function int main() {     int array[] = { 1, 1, 1, 2, 2, 2, 3 };     int n = sizeof(array) / sizeof(array[0]);     cout << sum(array, n);     return 0; } 

Output : 
 

3


Time complexity:O(n)
 

Please refer complete article on Number of pairs with maximum sum for more details!

Next Article
C++ Program to Count pairs with given sum
author
kartik
Improve
Article Tags :
  • Searching
  • C++ Programs
  • C++
  • DSA
  • Arrays
Practice Tags :
  • CPP
  • Arrays
  • Searching

Similar Reads

  • Number of pairs whose sum is a power of 2
    Given an array arr[] of positive integers, the task is to count the maximum possible number of pairs (arr[i], arr[j]) such that arr[i] + arr[j] is a power of 2.  Note: One element can be used at most once to form a pair. Examples:  Input: arr[] = {3, 11, 14, 5, 13} Output: 2 All valid pairs are (13,
    9 min read
  • C++ Program to Count pairs with given sum
    Given an array of integers, and a number 'sum', find the number of pairs of integers in the array whose sum is equal to 'sum'. Examples: Input : arr[] = {1, 5, 7, -1}, sum = 6 Output : 2 Pairs with sum 6 are (1, 5) and (7, -1) Input : arr[] = {1, 5, 7, -1, 5}, sum = 6 Output : 3 Pairs with sum 6 are
    4 min read
  • Count number of pairs with positive sum in an array
    Given an array arr[] of N integers, the task is to count the number of pairs with positive sum. Examples: Input: arr[] = {-7, -1, 3, 2} Output: 3 Explanation: The pairs with positive sum are: {-1, 3}, {-1, 2}, {3, 2}. Input: arr[] = {-4, -2, 5} Output: 2 Explanation: The pairs with positive sum are:
    9 min read
  • Maximum number of 3-person teams formed from two groups
    Given two integers N1 and N2 where, N1 is the number of people in group 1 and N2 is the number of people in group 2. The task is to count the maximum number of 3-person teams that can be formed when at least a single person is chosen from both the groups.Examples: Input: N1 = 2, N2 = 8 Output: 2 Tea
    9 min read
  • C++ Program for Find k pairs with smallest sums in two arrays
    Given two integer arrays arr1[] and arr2[] sorted in ascending order and an integer k. Find k pairs with smallest sums such that one element of a pair belongs to arr1[] and other element belongs to arr2[]Examples: Input : arr1[] = {1, 7, 11} arr2[] = {2, 4, 6} k = 3 Output : [1, 2], [1, 4], [1, 6] E
    7 min read
  • C++ Program for Maximum and Minimum in a square matrix.
    Given a square matrix of order n*n, find the maximum and minimum from the matrix given. Examples: Input : arr[][] = {5, 4, 9, 2, 0, 6, 3, 1, 8}; Output : Maximum = 9, Minimum = 0 Input : arr[][] = {-5, 3, 2, 4}; Output : Maximum = 4, Minimum = -5 Naive Method : We find maximum and minimum of matrix
    3 min read
  • Maximum OR value of a pair in an Array without using OR operator
    Given an array arr[] containing N positive integers, the task is to find the maximum bitwise OR value of a pair in the given array without using the Bitwise OR operator.Examples: Input: arr[] = {3, 6, 8, 16} Output: 24 Explanation: The pair giving maximum OR value is (8, 16) => 8|16 = 24Input: ar
    6 min read
  • C++ Program for Maximum equilibrium sum in an array
    Given an array arr[]. Find the maximum value of prefix sum which is also suffix sum for index i in arr[]. Examples : Input : arr[] = {-1, 2, 3, 0, 3, 2, -1} Output : 4 Prefix sum of arr[0..3] = Suffix sum of arr[3..6] Input : arr[] = {-2, 5, 3, 1, 2, 6, -4, 2} Output : 7 Prefix sum of arr[0..3] = Su
    4 min read
  • Sets of pairs in C++
    Sets are a type of associative containers in which each element has to be unique, because the value of the element identifies it. The value of the element cannot be modified once it is added to the set, though it is possible to remove and add the modified value of that element. Pair is a simple cont
    3 min read
  • Maximum OR value of a pair in an Array | Set 2
    Given an array arr[] of N positive elements, the task is to find the maximum bitwise OR value of a pair from the given array.Examples: Input: arr[] = {3, 6, 8, 16} Output: 24 Explanation: The pair giving maximum OR value is (8, 16) 8|16 = 24Input: arr[] = {8, 7, 3, 12} Output: 15 Explanation: There
    5 min read

geeksforgeeks-footer-logo
Corporate & Communications Address:
A-143, 7th Floor, Sovereign Corporate Tower, Sector- 136, Noida, Uttar Pradesh (201305)
Registered Address:
K 061, Tower K, Gulshan Vivante Apartment, Sector 137, Noida, Gautam Buddh Nagar, Uttar Pradesh, 201305
GFG App on Play Store GFG App on App Store
Advertise with us
  • Company
  • About Us
  • Legal
  • Privacy Policy
  • In Media
  • Contact Us
  • Advertise with us
  • GFG Corporate Solution
  • Placement Training Program
  • Languages
  • Python
  • Java
  • C++
  • PHP
  • GoLang
  • SQL
  • R Language
  • Android Tutorial
  • Tutorials Archive
  • DSA
  • Data Structures
  • Algorithms
  • DSA for Beginners
  • Basic DSA Problems
  • DSA Roadmap
  • Top 100 DSA Interview Problems
  • DSA Roadmap by Sandeep Jain
  • All Cheat Sheets
  • Data Science & ML
  • Data Science With Python
  • Data Science For Beginner
  • Machine Learning
  • ML Maths
  • Data Visualisation
  • Pandas
  • NumPy
  • NLP
  • Deep Learning
  • Web Technologies
  • HTML
  • CSS
  • JavaScript
  • TypeScript
  • ReactJS
  • NextJS
  • Bootstrap
  • Web Design
  • Python Tutorial
  • Python Programming Examples
  • Python Projects
  • Python Tkinter
  • Python Web Scraping
  • OpenCV Tutorial
  • Python Interview Question
  • Django
  • Computer Science
  • Operating Systems
  • Computer Network
  • Database Management System
  • Software Engineering
  • Digital Logic Design
  • Engineering Maths
  • Software Development
  • Software Testing
  • DevOps
  • Git
  • Linux
  • AWS
  • Docker
  • Kubernetes
  • Azure
  • GCP
  • DevOps Roadmap
  • System Design
  • High Level Design
  • Low Level Design
  • UML Diagrams
  • Interview Guide
  • Design Patterns
  • OOAD
  • System Design Bootcamp
  • Interview Questions
  • Inteview Preparation
  • Competitive Programming
  • Top DS or Algo for CP
  • Company-Wise Recruitment Process
  • Company-Wise Preparation
  • Aptitude Preparation
  • Puzzles
  • School Subjects
  • Mathematics
  • Physics
  • Chemistry
  • Biology
  • Social Science
  • English Grammar
  • Commerce
  • World GK
  • GeeksforGeeks Videos
  • DSA
  • Python
  • Java
  • C++
  • Web Development
  • Data Science
  • CS Subjects
@GeeksforGeeks, Sanchhaya Education Private Limited, All rights reserved
We use cookies to ensure you have the best browsing experience on our website. By using our site, you acknowledge that you have read and understood our Cookie Policy & Privacy Policy
Lightbox
Improvement
Suggest Changes
Help us improve. Share your suggestions to enhance the article. Contribute your expertise and make a difference in the GeeksforGeeks portal.
geeksforgeeks-suggest-icon
Create Improvement
Enhance the article with your expertise. Contribute to the GeeksforGeeks community and help create better learning resources for all.
geeksforgeeks-improvement-icon
Suggest Changes
min 4 words, max Words Limit:1000

Thank You!

Your suggestions are valuable to us.

What kind of Experience do you want to share?

Interview Experiences
Admission Experiences
Career Journeys
Work Experiences
Campus Experiences
Competitive Exam Experiences